# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

    OpenAPI spec version: 2.41
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re

import six
import typing

from ....properties import Property
if typing.TYPE_CHECKING:
    from pypureclient.flasharray.FA_2_41 import models

class CertificatePost(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'certificate': 'str',
        'common_name': 'str',
        'certificate_type': 'str',
        'country': 'str',
        'email': 'str',
        'intermediate_certificate': 'str',
        'issued_by': 'str',
        'issued_to': 'str',
        'locality': 'str',
        'organization': 'str',
        'organizational_unit': 'str',
        'state': 'str',
        'status': 'str',
        'subject_alternative_names': 'list[str]',
        'key_algorithm': 'str',
        'key_size': 'int',
        'valid_from': 'int',
        'valid_to': 'int',
        'days': 'int',
        'key': 'str',
        'passphrase': 'str'
    }

    attribute_map = {
        'certificate': 'certificate',
        'common_name': 'common_name',
        'certificate_type': 'certificate_type',
        'country': 'country',
        'email': 'email',
        'intermediate_certificate': 'intermediate_certificate',
        'issued_by': 'issued_by',
        'issued_to': 'issued_to',
        'locality': 'locality',
        'organization': 'organization',
        'organizational_unit': 'organizational_unit',
        'state': 'state',
        'status': 'status',
        'subject_alternative_names': 'subject_alternative_names',
        'key_algorithm': 'key_algorithm',
        'key_size': 'key_size',
        'valid_from': 'valid_from',
        'valid_to': 'valid_to',
        'days': 'days',
        'key': 'key',
        'passphrase': 'passphrase'
    }

    required_args = {
    }

    def __init__(
        self,
        certificate=None,  # type: str
        common_name=None,  # type: str
        certificate_type=None,  # type: str
        country=None,  # type: str
        email=None,  # type: str
        intermediate_certificate=None,  # type: str
        issued_by=None,  # type: str
        issued_to=None,  # type: str
        locality=None,  # type: str
        organization=None,  # type: str
        organizational_unit=None,  # type: str
        state=None,  # type: str
        status=None,  # type: str
        subject_alternative_names=None,  # type: List[str]
        key_algorithm=None,  # type: str
        key_size=None,  # type: int
        valid_from=None,  # type: int
        valid_to=None,  # type: int
        days=None,  # type: int
        key=None,  # type: str
        passphrase=None,  # type: str
    ):
        """
        Keyword args:
            certificate (str): The text of the certificate.
            common_name (str): The common name field listed in the certificate.
            certificate_type (str): The type of certificate. Values include `appliance` and `external`. Certificates of type `appliance` are used by the array to verify its identity to clients. Certificates of type `external` are used by the array to identify external servers to which it is configured to communicate.
            country (str): Two-letter country (ISO) code listed in the certificate.
            email (str): The email field listed in the certificate.
            intermediate_certificate (str): The text of the intermediate certificate chains.
            issued_by (str): The party that issued the certificate.
            issued_to (str): The party to whom the certificate is issued.
            locality (str): The locality field listed in the certificate.
            organization (str): The organization field listed in the certificate.
            organizational_unit (str): The organizational unit field listed in the certificate.
            state (str): The state/province field listed in the certificate.
            status (str): The type of certificate. Valid values are `self-signed` and `imported`.
            subject_alternative_names (list[str]): The alternative names that are secured by this certificate. Alternative names may be IP addresses, DNS names, or URIs.
            key_algorithm (str): The key algorithm used to generate the certificate. This field can only be specified when creating a new self-signed certificate. Defaults to rsa if not specified. Valid values when creating a new self-signed certificate only include `rsa`, `ec`, `ed448` and `ed25519`.
            key_size (int): The size (in bits) of the private key for the certificate. Default is 2048 bits for `rsa` key_algorithm, 256 for `ec` and `ed25519`. The `ed448` default key size is 456. This field can only be specified when creating a new self-signed certificate.
            valid_from (int): The date when the certificate starts being valid.
            valid_to (int): The date when the certificate stops being valid.
            days (int): The number of days that the self-signed certificate is valid. Defaults to 3650. This field can only be specified when creating a new self-signed certificate.
            key (str): The text of the private key. This field can only be specified when importing a certificate and key pair.
            passphrase (str): The passphrase used to encrypt `key`. This field can only be specified when importing a certificate and key pair.
        """
        if certificate is not None:
            self.certificate = certificate
        if common_name is not None:
            self.common_name = common_name
        if certificate_type is not None:
            self.certificate_type = certificate_type
        if country is not None:
            self.country = country
        if email is not None:
            self.email = email
        if intermediate_certificate is not None:
            self.intermediate_certificate = intermediate_certificate
        if issued_by is not None:
            self.issued_by = issued_by
        if issued_to is not None:
            self.issued_to = issued_to
        if locality is not None:
            self.locality = locality
        if organization is not None:
            self.organization = organization
        if organizational_unit is not None:
            self.organizational_unit = organizational_unit
        if state is not None:
            self.state = state
        if status is not None:
            self.status = status
        if subject_alternative_names is not None:
            self.subject_alternative_names = subject_alternative_names
        if key_algorithm is not None:
            self.key_algorithm = key_algorithm
        if key_size is not None:
            self.key_size = key_size
        if valid_from is not None:
            self.valid_from = valid_from
        if valid_to is not None:
            self.valid_to = valid_to
        if days is not None:
            self.days = days
        if key is not None:
            self.key = key
        if passphrase is not None:
            self.passphrase = passphrase

    def __setattr__(self, key, value):
        if key not in self.attribute_map:
            raise KeyError("Invalid key `{}` for `CertificatePost`".format(key))
        self.__dict__[key] = value

    def __getattribute__(self, item):
        value = object.__getattribute__(self, item)
        if isinstance(value, Property):
            raise AttributeError
        else:
            return value

    def __getitem__(self, key):
        if key not in self.attribute_map:
            raise KeyError("Invalid key `{}` for `CertificatePost`".format(key))
        return object.__getattribute__(self, key)

    def __setitem__(self, key, value):
        if key not in self.attribute_map:
            raise KeyError("Invalid key `{}` for `CertificatePost`".format(key))
        object.__setattr__(self, key, value)

    def __delitem__(self, key):
        if key not in self.attribute_map:
            raise KeyError("Invalid key `{}` for `CertificatePost`".format(key))
        object.__delattr__(self, key)

    def keys(self):
        return self.attribute_map.keys()

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            if hasattr(self, attr):
                value = getattr(self, attr)
                if isinstance(value, list):
                    result[attr] = list(map(
                        lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                        value
                    ))
                elif hasattr(value, "to_dict"):
                    result[attr] = value.to_dict()
                elif isinstance(value, dict):
                    result[attr] = dict(map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict") else item,
                        value.items()
                    ))
                else:
                    result[attr] = value
        if issubclass(CertificatePost, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CertificatePost):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
