# coding: utf-8

"""
    FlashBlade REST API

    A lightweight client for FlashBlade REST API 2.17, developed by Pure Storage, Inc. (http://www.purestorage.com/). 

    OpenAPI spec version: 2.17
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re

import six
import typing

from ....properties import Property
if typing.TYPE_CHECKING:
    from pypureclient.flashblade.FB_2_17 import models

class DirectoryService(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'id': 'str',
        'ca_certificate': 'Reference',
        'uris': 'list[str]',
        'base_dn': 'str',
        'bind_password': 'str',
        'management': 'DirectoryServiceManagement',
        'smb': 'DirectoryServiceSmb',
        'ca_certificate_group': 'Reference',
        'nfs': 'DirectoryServiceNfs',
        'services': 'list[str]',
        'bind_user': 'str',
        'enabled': 'bool'
    }

    attribute_map = {
        'name': 'name',
        'id': 'id',
        'ca_certificate': 'ca_certificate',
        'uris': 'uris',
        'base_dn': 'base_dn',
        'bind_password': 'bind_password',
        'management': 'management',
        'smb': 'smb',
        'ca_certificate_group': 'ca_certificate_group',
        'nfs': 'nfs',
        'services': 'services',
        'bind_user': 'bind_user',
        'enabled': 'enabled'
    }

    required_args = {
    }

    def __init__(
        self,
        name=None,  # type: str
        id=None,  # type: str
        ca_certificate=None,  # type: models.Reference
        uris=None,  # type: List[str]
        base_dn=None,  # type: str
        bind_password=None,  # type: str
        management=None,  # type: models.DirectoryServiceManagement
        smb=None,  # type: models.DirectoryServiceSmb
        ca_certificate_group=None,  # type: models.Reference
        nfs=None,  # type: models.DirectoryServiceNfs
        services=None,  # type: List[str]
        bind_user=None,  # type: str
        enabled=None,  # type: bool
    ):
        """
        Keyword args:
            name (str): Name of the object (e.g., a file system or snapshot).
            id (str): A non-modifiable, globally unique ID chosen by the system. 
            ca_certificate (Reference): CA certificate used to validate the authenticity of the configured servers. 
            uris (list[str]): List of URIs for the configured directory servers.
            base_dn (str): Base of the Distinguished Name (DN) of the directory service groups. 
            bind_password (str): Obfuscated password used to query the directory.
            management (DirectoryServiceManagement)
            smb (DirectoryServiceSmb)
            ca_certificate_group (Reference): A certificate group containing CA certificates that can be used to validate the authenticity of the configured servers. 
            nfs (DirectoryServiceNfs)
            services (list[str]): Services that the directory service configuration is used for. 
            bind_user (str): Username used to query the directory.
            enabled (bool): Is the directory service enabled or not?
        """
        if name is not None:
            self.name = name
        if id is not None:
            self.id = id
        if ca_certificate is not None:
            self.ca_certificate = ca_certificate
        if uris is not None:
            self.uris = uris
        if base_dn is not None:
            self.base_dn = base_dn
        if bind_password is not None:
            self.bind_password = bind_password
        if management is not None:
            self.management = management
        if smb is not None:
            self.smb = smb
        if ca_certificate_group is not None:
            self.ca_certificate_group = ca_certificate_group
        if nfs is not None:
            self.nfs = nfs
        if services is not None:
            self.services = services
        if bind_user is not None:
            self.bind_user = bind_user
        if enabled is not None:
            self.enabled = enabled

    def __setattr__(self, key, value):
        if key not in self.attribute_map:
            raise KeyError("Invalid key `{}` for `DirectoryService`".format(key))
        self.__dict__[key] = value

    def __getattribute__(self, item):
        value = object.__getattribute__(self, item)
        if isinstance(value, Property):
            return None
        else:
            return value

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            if hasattr(self, attr):
                value = getattr(self, attr)
                if isinstance(value, list):
                    result[attr] = list(map(
                        lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                        value
                    ))
                elif hasattr(value, "to_dict"):
                    result[attr] = value.to_dict()
                elif isinstance(value, dict):
                    result[attr] = dict(map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict") else item,
                        value.items()
                    ))
                else:
                    result[attr] = value
        if issubclass(DirectoryService, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DirectoryService):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
