# coding: utf-8

"""
    FlashBlade REST API

    A lightweight client for FlashBlade REST API 2.17, developed by Pure Storage, Inc. (http://www.purestorage.com/). 

    OpenAPI spec version: 2.17
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re

import six
import typing

from ....properties import Property
if typing.TYPE_CHECKING:
    from pypureclient.flashblade.FB_2_17 import models

class FleetMember(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'fleet': 'FixedReferenceWithIsLocal',
        'member': 'FixedReferenceWithIsLocal',
        'status_details': 'str',
        'status': 'str'
    }

    attribute_map = {
        'fleet': 'fleet',
        'member': 'member',
        'status_details': 'status_details',
        'status': 'status'
    }

    required_args = {
    }

    def __init__(
        self,
        fleet=None,  # type: models.FixedReferenceWithIsLocal
        member=None,  # type: models.FixedReferenceWithIsLocal
        status_details=None,  # type: str
        status=None,  # type: str
    ):
        """
        Keyword args:
            fleet (FixedReferenceWithIsLocal)
            member (FixedReferenceWithIsLocal)
            status_details (str): Describes the error, if any.
            status (str): Current fleet membership status. Valid values include: `joining`, `joined`, or `removing`. A status of `joining` indicates that the member is attempting to join the fleet. A status of `joined` indicates that the member has joined the fleet. A status of `removing` indicates that the member is being removed from the fleet.
        """
        if fleet is not None:
            self.fleet = fleet
        if member is not None:
            self.member = member
        if status_details is not None:
            self.status_details = status_details
        if status is not None:
            self.status = status

    def __setattr__(self, key, value):
        if key not in self.attribute_map:
            raise KeyError("Invalid key `{}` for `FleetMember`".format(key))
        self.__dict__[key] = value

    def __getattribute__(self, item):
        value = object.__getattribute__(self, item)
        if isinstance(value, Property):
            return None
        else:
            return value

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            if hasattr(self, attr):
                value = getattr(self, attr)
                if isinstance(value, list):
                    result[attr] = list(map(
                        lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                        value
                    ))
                elif hasattr(value, "to_dict"):
                    result[attr] = value.to_dict()
                elif isinstance(value, dict):
                    result[attr] = dict(map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict") else item,
                        value.items()
                    ))
                else:
                    result[attr] = value
        if issubclass(FleetMember, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FleetMember):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
