# coding: utf-8

"""
    FlashBlade REST API

    A lightweight client for FlashBlade REST API 2.17, developed by Pure Storage, Inc. (http://www.purestorage.com/). 

    OpenAPI spec version: 2.17
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re

import six
import typing

from ....properties import Property
if typing.TYPE_CHECKING:
    from pypureclient.flashblade.FB_2_17 import models

class NetworkInterfacesConnectorsSettingRocePfc(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'xoff_threshold': 'int',
        'xon_threshold': 'int',
        'port_buffer': 'int'
    }

    attribute_map = {
        'xoff_threshold': 'xoff_threshold',
        'xon_threshold': 'xon_threshold',
        'port_buffer': 'port_buffer'
    }

    required_args = {
    }

    def __init__(
        self,
        xoff_threshold=None,  # type: int
        xon_threshold=None,  # type: int
        port_buffer=None,  # type: int
    ):
        """
        Keyword args:
            xoff_threshold (int): The PFC XOFF threshold value in bytes. When the buffer for a particular traffic class reaches this threshold, the pause frame(XOFF) will be transimitted to the sender, requesting it to stop sending packets for that class. 
            xon_threshold (int): The PFC XON threshold value in bytes. When the buffer for a particular traffic class drops below this threshold, the un-pause frame(XON) will be transmitted to the sender, requesting it to resume sending packets for that class. 
            port_buffer (int): The buffer size in bytes reserved to absorb in-flight packets after XOFF threshold is reached. 
        """
        if xoff_threshold is not None:
            self.xoff_threshold = xoff_threshold
        if xon_threshold is not None:
            self.xon_threshold = xon_threshold
        if port_buffer is not None:
            self.port_buffer = port_buffer

    def __setattr__(self, key, value):
        if key not in self.attribute_map:
            raise KeyError("Invalid key `{}` for `NetworkInterfacesConnectorsSettingRocePfc`".format(key))
        self.__dict__[key] = value

    def __getattribute__(self, item):
        value = object.__getattribute__(self, item)
        if isinstance(value, Property):
            return None
        else:
            return value

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            if hasattr(self, attr):
                value = getattr(self, attr)
                if isinstance(value, list):
                    result[attr] = list(map(
                        lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                        value
                    ))
                elif hasattr(value, "to_dict"):
                    result[attr] = value.to_dict()
                elif isinstance(value, dict):
                    result[attr] = dict(map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict") else item,
                        value.items()
                    ))
                else:
                    result[attr] = value
        if issubclass(NetworkInterfacesConnectorsSettingRocePfc, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NetworkInterfacesConnectorsSettingRocePfc):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
