# coding: utf-8

"""
    FlashBlade REST API

    A lightweight client for FlashBlade REST API 2.17, developed by Pure Storage, Inc. (http://www.purestorage.com/). 

    OpenAPI spec version: 2.17
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re

import six
import typing

from ....properties import Property
if typing.TYPE_CHECKING:
    from pypureclient.flashblade.FB_2_17 import models

class QosPolicy(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'id': 'str',
        'policy_type': 'str',
        'location': 'FixedReference',
        'is_local': 'bool',
        'enabled': 'bool',
        'max_total_bytes_per_sec': 'int',
        'max_total_ops_per_sec': 'int'
    }

    attribute_map = {
        'name': 'name',
        'id': 'id',
        'policy_type': 'policy_type',
        'location': 'location',
        'is_local': 'is_local',
        'enabled': 'enabled',
        'max_total_bytes_per_sec': 'max_total_bytes_per_sec',
        'max_total_ops_per_sec': 'max_total_ops_per_sec'
    }

    required_args = {
    }

    def __init__(
        self,
        name=None,  # type: str
        id=None,  # type: str
        policy_type=None,  # type: str
        location=None,  # type: models.FixedReference
        is_local=None,  # type: bool
        enabled=None,  # type: bool
        max_total_bytes_per_sec=None,  # type: int
        max_total_ops_per_sec=None,  # type: int
    ):
        """
        Keyword args:
            name (str): A name chosen by the user. Can be changed. Must be locally unique. 
            id (str): A non-modifiable, globally unique ID chosen by the system. 
            policy_type (str): Type of the policy. Valid values include `alert`, `audit`, `bucket-access`, `cross-origin-resource-sharing`, `network-access`, `nfs`, `object-access`, `smb-client`, `smb-share`, `snapshot`, `ssh-certificate-authority`, and `worm-data`. 
            location (FixedReference): Reference to the array where the policy is defined.
            is_local (bool): Whether the policy is defined on the local array.
            enabled (bool): If `true`, the policy is enabled. If not specified, defaults to `true`. 
            max_total_bytes_per_sec (int): The maximum allowed bytes/s totaled across all the clients. Throttling occurs when the total bandwidth exceeds this limit. Minimum limit is 1MB/s and maximum limit is 512GB/s. If not specified at creation time, defaults to `null` to indicate no limit. 
            max_total_ops_per_sec (int): The maximum allowed operations/s totaled across all the clients. Throttling occurs when the total IOPs exceeds this limit. Minimum limit is 100 IOPs/s and maximum limit is 100M IOPs/s. If not specified at creation time, defaults to `null` to indicate no limit. 
        """
        if name is not None:
            self.name = name
        if id is not None:
            self.id = id
        if policy_type is not None:
            self.policy_type = policy_type
        if location is not None:
            self.location = location
        if is_local is not None:
            self.is_local = is_local
        if enabled is not None:
            self.enabled = enabled
        if max_total_bytes_per_sec is not None:
            self.max_total_bytes_per_sec = max_total_bytes_per_sec
        if max_total_ops_per_sec is not None:
            self.max_total_ops_per_sec = max_total_ops_per_sec

    def __setattr__(self, key, value):
        if key not in self.attribute_map:
            raise KeyError("Invalid key `{}` for `QosPolicy`".format(key))
        if key == "max_total_bytes_per_sec" and value is not None:
            if value > 549755813888:
                raise ValueError("Invalid value for `max_total_bytes_per_sec`, value must be less than or equal to `549755813888`")
            if value < 1048576:
                raise ValueError("Invalid value for `max_total_bytes_per_sec`, must be a value greater than or equal to `1048576`")
        if key == "max_total_ops_per_sec" and value is not None:
            if value > 100000000:
                raise ValueError("Invalid value for `max_total_ops_per_sec`, value must be less than or equal to `100000000`")
            if value < 100:
                raise ValueError("Invalid value for `max_total_ops_per_sec`, must be a value greater than or equal to `100`")
        self.__dict__[key] = value

    def __getattribute__(self, item):
        value = object.__getattribute__(self, item)
        if isinstance(value, Property):
            return None
        else:
            return value

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            if hasattr(self, attr):
                value = getattr(self, attr)
                if isinstance(value, list):
                    result[attr] = list(map(
                        lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                        value
                    ))
                elif hasattr(value, "to_dict"):
                    result[attr] = value.to_dict()
                elif isinstance(value, dict):
                    result[attr] = dict(map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict") else item,
                        value.items()
                    ))
                else:
                    result[attr] = value
        if issubclass(QosPolicy, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, QosPolicy):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
