# coding: utf-8

"""
    FlashBlade REST API

    A lightweight client for FlashBlade REST API 2.17, developed by Pure Storage, Inc. (http://www.purestorage.com/). 

    OpenAPI spec version: 2.17
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re

import six
import typing

from ....properties import Property
if typing.TYPE_CHECKING:
    from pypureclient.flashblade.FB_2_17 import models

class RelationshipPerformanceReplication(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'context': 'Reference',
        'periodic': 'ReplicationPerformance',
        'continuous': 'ContinuousReplicationPerformance',
        'time': 'int',
        'aggregate': 'ReplicationPerformance'
    }

    attribute_map = {
        'id': 'id',
        'context': 'context',
        'periodic': 'periodic',
        'continuous': 'continuous',
        'time': 'time',
        'aggregate': 'aggregate'
    }

    required_args = {
    }

    def __init__(
        self,
        id=None,  # type: str
        context=None,  # type: models.Reference
        periodic=None,  # type: models.ReplicationPerformance
        continuous=None,  # type: models.ContinuousReplicationPerformance
        time=None,  # type: int
        aggregate=None,  # type: models.ReplicationPerformance
    ):
        """
        Keyword args:
            id (str): A non-modifiable, globally unique ID chosen by the system. 
            context (Reference): The context in which the operation was performed. Valid values include a reference to any array which is a member of the same fleet. If the array is not a member of a fleet, `context` will always implicitly be set to the array that received the request.  Other parameters provided with the request, such as names of volumes or snapshots,  are resolved relative to the provided `context`. 
            periodic (ReplicationPerformance): Total bytes transmitted or received per second for periodic replication. Periodic replication includes file system replication, which is snapshot based. 
            continuous (ContinuousReplicationPerformance): Object backlog information and total bytes transmitted or received per second for continuous replication. Continuous replication includes object replication. 
            time (int): Sample time in milliseconds since UNIX epoch.
            aggregate (ReplicationPerformance): Total bytes transmitted or received per second for all types of replication. 
        """
        if id is not None:
            self.id = id
        if context is not None:
            self.context = context
        if periodic is not None:
            self.periodic = periodic
        if continuous is not None:
            self.continuous = continuous
        if time is not None:
            self.time = time
        if aggregate is not None:
            self.aggregate = aggregate

    def __setattr__(self, key, value):
        if key not in self.attribute_map:
            raise KeyError("Invalid key `{}` for `RelationshipPerformanceReplication`".format(key))
        self.__dict__[key] = value

    def __getattribute__(self, item):
        value = object.__getattribute__(self, item)
        if isinstance(value, Property):
            return None
        else:
            return value

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            if hasattr(self, attr):
                value = getattr(self, attr)
                if isinstance(value, list):
                    result[attr] = list(map(
                        lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                        value
                    ))
                elif hasattr(value, "to_dict"):
                    result[attr] = value.to_dict()
                elif isinstance(value, dict):
                    result[attr] = dict(map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict") else item,
                        value.items()
                    ))
                else:
                    result[attr] = value
        if issubclass(RelationshipPerformanceReplication, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RelationshipPerformanceReplication):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
