# coding: utf-8

"""
    FlashBlade REST API

    A lightweight client for FlashBlade REST API 2.17, developed by Pure Storage, Inc. (http://www.purestorage.com/). 

    OpenAPI spec version: 2.17
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re

import six
import typing

from ....properties import Property
if typing.TYPE_CHECKING:
    from pypureclient.flashblade.FB_2_17 import models

class SupportDiagnostics(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'id': 'str',
        'start_time': 'int',
        'index': 'int',
        'task_id': 'str',
        'analysis_period': 'StartEndTime',
        'version': 'str',
        'severity_count': 'list[SupportDiagnosticsSeverityCount]',
        'status': 'str'
    }

    attribute_map = {
        'name': 'name',
        'id': 'id',
        'start_time': 'start_time',
        'index': 'index',
        'task_id': 'task_id',
        'analysis_period': 'analysis_period',
        'version': 'version',
        'severity_count': 'severity_count',
        'status': 'status'
    }

    required_args = {
    }

    def __init__(
        self,
        name=None,  # type: str
        id=None,  # type: str
        start_time=None,  # type: int
        index=None,  # type: int
        task_id=None,  # type: str
        analysis_period=None,  # type: models.StartEndTime
        version=None,  # type: str
        severity_count=None,  # type: List[models.SupportDiagnosticsSeverityCount]
        status=None,  # type: str
    ):
        """
        Keyword args:
            name (str): Name of the object (e.g., a file system or snapshot).
            id (str): A non-modifiable, globally unique ID chosen by the system. 
            start_time (int): Start time in milliseconds since the UNIX epoch.
            index (int): The unique index of the task.
            task_id (str): A globally unique, system-generated ID. The ID cannot be modified. 
            analysis_period (StartEndTime)
            version (str): Version of diagnostics tool.
            severity_count (list[SupportDiagnosticsSeverityCount]): List of severity counts. 
            status (str): Status of the diagnostics. A status of `running` indicates that the diagnostics is still running. A status of `completed` indicates that the diagnostics has completed. A status of `failed` indicates that the diagnostics has failed. 
        """
        if name is not None:
            self.name = name
        if id is not None:
            self.id = id
        if start_time is not None:
            self.start_time = start_time
        if index is not None:
            self.index = index
        if task_id is not None:
            self.task_id = task_id
        if analysis_period is not None:
            self.analysis_period = analysis_period
        if version is not None:
            self.version = version
        if severity_count is not None:
            self.severity_count = severity_count
        if status is not None:
            self.status = status

    def __setattr__(self, key, value):
        if key not in self.attribute_map:
            raise KeyError("Invalid key `{}` for `SupportDiagnostics`".format(key))
        self.__dict__[key] = value

    def __getattribute__(self, item):
        value = object.__getattribute__(self, item)
        if isinstance(value, Property):
            return None
        else:
            return value

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            if hasattr(self, attr):
                value = getattr(self, attr)
                if isinstance(value, list):
                    result[attr] = list(map(
                        lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                        value
                    ))
                elif hasattr(value, "to_dict"):
                    result[attr] = value.to_dict()
                elif isinstance(value, dict):
                    result[attr] = dict(map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict") else item,
                        value.items()
                    ))
                else:
                    result[attr] = value
        if issubclass(SupportDiagnostics, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SupportDiagnostics):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
