# coding: utf-8

"""
    Pure1 Public REST API

    Pure1 Public REST API, developed by [Pure Storage, Inc.](https://www.purestorage.com)   The Pure1 REST API 2.0 offers one single form of authentication: OAuth 2.0 via the [Token Exchange protocol](https://datatracker.ietf.org/doc/draft-ietf-oauth-token-exchange).  OAuth 2.0 is an open protocol to allow secure authorization in a simple and standard method from web, mobile, desktop and background applications.  Note that the [Authentication](#section/Authentication) section below mentions 'API Key' as the security scheme type. This is solely for the purpose of allowing testing this API with [Swagger UI](https://static.pure1.purestorage.com/api-swagger/index.html).  [Knowledge base reference documentation](https://support.purestorage.com/Pure1/Pure1_Manage/Pure1_Manage_-_REST_API/Pure1_Manage_-_REST_API__Reference)

    OpenAPI spec version: 1.4
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re

import six
import typing

from ....properties import Property
if typing.TYPE_CHECKING:
    from pypureclient.pure1.Pure1_1_4 import models

class Subscription(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'as_of': 'int',
        'name': 'str',
        'id': 'str',
        'service_details': 'object',
        'initial_name': 'str',
        'partner_name': 'str',
        'service': 'str',
        'organization': 'FixedReference',
        'subscription_term': 'int',
        'expiration_date': 'int',
        'last_updated_date': 'int',
        'start_date': 'int',
        'status': 'str'
    }

    attribute_map = {
        'as_of': '_as_of',
        'name': 'name',
        'id': 'id',
        'service_details': 'service_details',
        'initial_name': 'initial_name',
        'partner_name': 'partner_name',
        'service': 'service',
        'organization': 'organization',
        'subscription_term': 'subscription_term',
        'expiration_date': 'expiration_date',
        'last_updated_date': 'last_updated_date',
        'start_date': 'start_date',
        'status': 'status'
    }

    required_args = {
    }

    def __init__(
        self,
        as_of=None,  # type: int
        name=None,  # type: str
        id=None,  # type: str
        service_details=None,  # type: object
        initial_name=None,  # type: str
        partner_name=None,  # type: str
        service=None,  # type: str
        organization=None,  # type: models.FixedReference
        subscription_term=None,  # type: int
        expiration_date=None,  # type: int
        last_updated_date=None,  # type: int
        start_date=None,  # type: int
        status=None,  # type: str
    ):
        """
        Keyword args:
            as_of (int): The freshness of the data (timestamp in millis since epoch).
            name (str): A non-modifiable, locally unique name chosen by the system.
            id (str): A non-modifiable, globally unique ID chosen by the system.
            service_details (object): Additional details for the given service. 
            initial_name (str): A non-modifiable, locally unique name that the subscription was started with, never changes. 
            partner_name (str): The partner who invoices for the subscription.
            service (str): The service type of the subscription. Values include `Evergreen//One`, `Evergreen//Flex`, `FlashStack as a Service`, `Storage as a Service`, `PaaS (Block Storage Service)`, `PaaS (File and Object Storage Service)`, `PaaS (Data Protection Service)`, and `Pure1 Subscription`. 
            organization (FixedReference): The Pure1 organization for the subscription.
            subscription_term (int): Length of the subscription in months.
            expiration_date (int): Date when the subscription expires. Represented as a timestamp of 00:00 on that date in UTC, in milliseconds since UNIX epoch. 
            last_updated_date (int): The date of the last amendment to the current subscription. Represented as a timestamp of 00:00 on that date in UTC, in milliseconds since UNIX epoch. 
            start_date (int): Date when the subscription starts. Represented as a timestamp of 00:00 on that date in UTC, in milliseconds since UNIX epoch. 
            status (str): Current status of the subscription. Values include `active`, `terminated`, `poc-expired`, and `signed`. 
        """
        if as_of is not None:
            self.as_of = as_of
        if name is not None:
            self.name = name
        if id is not None:
            self.id = id
        if service_details is not None:
            self.service_details = service_details
        if initial_name is not None:
            self.initial_name = initial_name
        if partner_name is not None:
            self.partner_name = partner_name
        if service is not None:
            self.service = service
        if organization is not None:
            self.organization = organization
        if subscription_term is not None:
            self.subscription_term = subscription_term
        if expiration_date is not None:
            self.expiration_date = expiration_date
        if last_updated_date is not None:
            self.last_updated_date = last_updated_date
        if start_date is not None:
            self.start_date = start_date
        if status is not None:
            self.status = status

    def __setattr__(self, key, value):
        if key not in self.attribute_map:
            raise KeyError("Invalid key `{}` for `Subscription`".format(key))
        self.__dict__[key] = value

    def __getattribute__(self, item):
        value = object.__getattribute__(self, item)
        if isinstance(value, Property):
            raise AttributeError
        else:
            return value

    def __getitem__(self, key):
        if key not in self.attribute_map:
            raise KeyError("Invalid key `{}` for `Subscription`".format(key))
        return object.__getattribute__(self, key)

    def __setitem__(self, key, value):
        if key not in self.attribute_map:
            raise KeyError("Invalid key `{}` for `Subscription`".format(key))
        object.__setattr__(self, key, value)

    def __delitem__(self, key):
        if key not in self.attribute_map:
            raise KeyError("Invalid key `{}` for `Subscription`".format(key))
        object.__delattr__(self, key)

    def keys(self):
        return self.attribute_map.keys()

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            if hasattr(self, attr):
                value = getattr(self, attr)
                if isinstance(value, list):
                    result[attr] = list(map(
                        lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                        value
                    ))
                elif hasattr(value, "to_dict"):
                    result[attr] = value.to_dict()
                elif isinstance(value, dict):
                    result[attr] = dict(map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict") else item,
                        value.items()
                    ))
                else:
                    result[attr] = value
        if issubclass(Subscription, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Subscription):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
